#include <iostream>
using namespace std;
#include "ButtonClass.h"
using namespace ButtonWindow;

ButtonClass::ButtonClass(int argc, char ** argv)
{
  const int W_WIDTH = 320;
  const int W_HEIGHT = 130;

  window = new Window((screenInfo().w - W_WIDTH)/2,(screenInfo().h - W_HEIGHT)/2,W_WIDTH,W_HEIGHT,"Buttons",true);

  (void) new Button(10, 10, 130, 24, "Button");
  rtb = new ReturnButton(150, 10, 130, 24, "ReturnButton");
  (void) new RepeatButton(10,40,130,24,"RepeatButton");
  rdb = new RadioButton(150,40,130,24,"RadioButton");
  rdb->value(true);
  //rdb->labelcolor(256-36);

  (void) new RadioButton(150,70,130,24,"RadioButton");
  (void) new LightButton(10,70,130,24,"LightButton");
  (void) new CheckButton(150,100,130,24,"CheckButton");
  (void) new HighlightButton(10,100,130,24,"HighlightButton");

  //Styles
  Button::default_style->box = PLASTIC_UP_BOX;
  Button::default_style->color = 256-36;

  //Event Handling
#ifdef _NO_CLASS_CALLBACK
  rtb->callback(rtb_callback,(void*)this);
#else
  rtb->callback(this,Fl_CBMethodCast(ButtonClass,rtb_Click),(void*)"ReturnButton CCB");
#endif

  window->resizable(window);
  window->end();
  window->show(argc,argv);
}

ButtonClass::~ButtonClass(){
	delete rdb;
	rdb = NULL;
	delete rtb;
	rtb = NULL;
	delete window;
	window = NULL;
}

void ButtonClass::rtb_Click(Widget * widget, void * userData)
{
	window->position((screenInfo().w - window->width())/2,(screenInfo().h - window->height())/2);
#ifndef _NO_CLASS_CALLBACK
	char * str = (char*)userData;
	if(str)	widget->label(str);
	cout << "ButtonClass::rtb_Click member function called." << endl;
	cout << "this=" << this << ", widget=" << widget << ", userData=" << str << endl << endl;
#endif
	widget->labelcolor(256-36);
}
